com.fasterxml.jackson.databind.jsontype.impl

## Class ClassNameIdResolver

- java.lang.Object
- - com.fasterxml.jackson.databind.jsontype.impl.TypeIdResolverBase
  - - com.fasterxml.jackson.databind.jsontype.impl.ClassNameIdResolver

- All Implemented Interfaces:
    TypeIdResolver
  Direct Known Subclasses:
    MinimalClassNameIdResolver

      public class ClassNameIdResolver
      extends TypeIdResolverBase

  `TypeIdResolver` implementation that converts between fully-qualified Java class names and (JSON) Strings.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected PolymorphicTypeValidator` | `_subTypeValidator`

    - ### Fields inherited from class com.fasterxml.jackson.databind.jsontype.impl.TypeIdResolverBase

      `_baseType, _typeFactory`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `ClassNameIdResolver(JavaType baseType, TypeFactory typeFactory)` Deprecated. Since 2.10 use variant that takes `PolymorphicTypeValidator`
    `` | `ClassNameIdResolver(JavaType baseType, TypeFactory typeFactory, PolymorphicTypeValidator ptv)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected String` | `_idFrom(Object value, Class<?> cls, TypeFactory typeFactory)`
    `protected JavaType` | `_typeFromId(String id, DatabindContext ctxt)`
    `static ClassNameIdResolver` | `construct(JavaType baseType, MapperConfig<?> config, PolymorphicTypeValidator ptv)`
    `String` | `getDescForKnownTypeIds()` Helper method used to get a simple description of all known type ids, for use in error messages.
    `JsonTypeInfo.Id` | `getMechanism()` Accessor for mechanism that this resolver uses for determining type id from type.
    `String` | `idFromValue(Object value)` Method called to serialize type of the type of given value as a String to include in serialized JSON content.
    `String` | `idFromValueAndType(Object value, Class<?> type)` Alternative method used for determining type from combination of value and type, using suggested type (that serializer provides) and possibly value of that type.
    `void` | `registerSubtype(Class<?> type, String name)`
    `JavaType` | `typeFromId(DatabindContext context, String id)` Method called to resolve type from given type identifier.

    - ### Methods inherited from class com.fasterxml.jackson.databind.jsontype.impl.TypeIdResolverBase

      `idFromBaseType, init`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### _subTypeValidator

          protected final PolymorphicTypeValidator _subTypeValidator

  - ### Constructor Detail

    - #### ClassNameIdResolver

          @Deprecated
          protected ClassNameIdResolver(JavaType baseType,
                                                    TypeFactory typeFactory)

      Deprecated. Since 2.10 use variant that takes `PolymorphicTypeValidator`

    - #### ClassNameIdResolver

          public ClassNameIdResolver(JavaType baseType,
                                     TypeFactory typeFactory,
                                     PolymorphicTypeValidator ptv)

      Since:
        2.10

  - ### Method Detail

    - #### construct

          public static ClassNameIdResolver construct(JavaType baseType,
                                                      MapperConfig<?> config,
                                                      PolymorphicTypeValidator ptv)

    - #### getMechanism

          public JsonTypeInfo.Id getMechanism()

      Description copied from interface: `TypeIdResolver`
      Accessor for mechanism that this resolver uses for determining type id from type. Mostly informational; not required to be called or used.

    - #### registerSubtype

          public void registerSubtype(Class<?> type,
                                      String name)

    - #### idFromValue

          public String idFromValue(Object value)

      Description copied from interface: `TypeIdResolver`
      Method called to serialize type of the type of given value as a String to include in serialized JSON content.

    - #### idFromValueAndType

          public String idFromValueAndType(Object value,
                                           Class<?> type)

      Description copied from interface: `TypeIdResolver`
      Alternative method used for determining type from combination of value and type, using suggested type (that serializer provides) and possibly value of that type. Most common implementation will use suggested type as is.

    - #### typeFromId

          public JavaType typeFromId(DatabindContext context,
                                     String id)
                              throws IOException

      Description copied from interface: `TypeIdResolver`
      Method called to resolve type from given type identifier.
      Specified by:
        `typeFromId` in interface `TypeIdResolver`
      Overrides:
        `typeFromId` in class `TypeIdResolverBase`
      Throws:
        `IOException`

    - #### _typeFromId

          protected JavaType _typeFromId(String id,
                                         DatabindContext ctxt)
                                  throws IOException

      Throws:
        `IOException`

    - #### _idFrom

          protected String _idFrom(Object value,
                                   Class<?> cls,
                                   TypeFactory typeFactory)

    - #### getDescForKnownTypeIds

          public String getDescForKnownTypeIds()

      Description copied from class: `TypeIdResolverBase`
      Helper method used to get a simple description of all known type ids, for use in error messages.
      Specified by:
        `getDescForKnownTypeIds` in interface `TypeIdResolver`
      Overrides:
        `getDescForKnownTypeIds` in class `TypeIdResolverBase`

Copyright © 2008–2020 FasterXML. All rights reserved.